---
title: BeforeInstallPromptEvent
slug: Web/API/BeforeInstallPromptEvent
tags:
  - API
  - BeforeInstallPromptEvent
  - Event
  - Experimental
  - Interface
  - Reference
---
<div>The <code><strong>BeforeInstallPromptEvent</strong></code> is fired at the {{domxref("Window.onbeforeinstallprompt")}} handler<span style="line-height: 19.0909080505371px;"> before a user is prompted to "install" a web site to a home screen on mobile.</span></div>

<p>This interface inherits from the {{domxref("Event")}} interface.</p>

<p>{{InheritanceDiagram(700, 60, 20)}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("BeforeInstallPromptEvent.BeforeInstallPromptEvent","BeforeInstallPromptEvent()")}}</dt>
 <dd>Creates a new <code><strong>BeforeInstallPromptEvent</strong></code>.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>Inherits properties from its parent, {{domxref("Event")}}.</em></p>

<dl>
 <dt>{{domxref("BeforeInstallPromptEvent.platforms")}} {{readonlyinline}}</dt>
 <dd>Returns an array of {{domxref("DOMString")}} items containing the platforms on which the event was dispatched. This is provided for user agents that want to present a choice of versions to the user such as, for example, "web" or "play" which would allow the user to chose between a web version or an Android version.</dd>
 <dt>{{domxref("BeforeInstallPromptEvent.userChoice")}} {{readonlyinline}}</dt>
 <dd>Returns a {{jsxref("Promise")}} that resolves to a {{domxref("DOMString")}} containing either "accepted" or "dismissed".</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("BeforeInstallPromptEvent.prompt()")}} </dt>
 <dd>Allows a developer to show the install prompt at a time of their own choosing. This method returns a  {{jsxref("Promise")}}.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">window.addEventListener("beforeinstallprompt", function(e) {
  // log the platforms provided as options in an install prompt
  console.log(e.platforms); // e.g., ["web", "android", "windows"]
  e.userChoice.then(function(choiceResult) {
    console.log(choiceResult.outcome); // either "accepted" or "dismissed"
  }, handleError);
});
</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BeforeInstallPromptEvent")}}</p>
